package cn.efunbox.audio.controller;

import cn.efunbox.audio.entity.Album;
import cn.efunbox.audio.page.OnePage;
import cn.efunbox.audio.service.AdminService;
import cn.efunbox.audio.service.AlbumService;
import cn.efunbox.audio.service.TrailService;
import cn.efunbox.audio.utils.ApiCode;
import cn.efunbox.audio.utils.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigInteger;
import java.util.List;
import java.util.Objects;

/**
 * AlbumController
 * Created by xusq on 2018/5/8.
 */
@RestController
@Slf4j
@RequestMapping(value = "/album")
public class AlbumController {

    @Autowired
    private AlbumService albumService;
    @Autowired
    private TrailService trailService;
    @Autowired
    private AdminService adminService;


    @RequestMapping(method = RequestMethod.POST)
    public void Insert(HttpServletRequest request, HttpServletResponse response, @RequestBody Album album){
        List<Album> list = albumService.searchByName(album.getName());
        if(list!=null && list.size()>0){
            HttpUtil.responseApiCode(request, response, ApiCode.RECORD_EXIST);
            return;
        }

        album = albumService.Insert(album);

        TrailController.Insert(adminService, trailService, request, "album", album.getId().longValue(), " 新建专辑：" + album.getName());

        HttpUtil.responseOkData(request, response, album);
        return;
    }

    @RequestMapping( method = RequestMethod.PUT)
    public void Update(HttpServletRequest request, HttpServletResponse response, @RequestBody Album album){
        Album albumOld = albumService.GetOne(album.getId());
        if(albumOld==null){
            HttpUtil.responseApiCode(request, response, ApiCode.PARAMETER_ERROR);
            return;
        }
        album = albumService.Update(album);

        TrailController.Insert(adminService, trailService, request, "album", album.getId().longValue(), " 更新专辑：" + album.getName());

        HttpUtil.responseOkData(request, response, album);
        return;
    }

    @RequestMapping(method = RequestMethod.GET)
    public void list(HttpServletRequest request, HttpServletResponse response,Album album, Integer pageNo, Integer pageSize){

        album.setId(null);
        if (Objects.nonNull(pageSize) && pageSize > 100) {
            pageSize = 100;
        }

        OnePage<Album> albumPage = albumService.SearchAll(album,pageNo,pageSize);

        HttpUtil.responseOkData(request, response, albumPage);
        return;
    }

    @GetMapping("/{albumId}")
    public void list(HttpServletRequest request, HttpServletResponse response,@PathVariable(name = "albumId") BigInteger albumId){

        Album album = albumService.GetOne(albumId);

        HttpUtil.responseOkData(request, response, album);
        return;
    }
}
