package cn.efunbox.audio.controller;

import cn.efunbox.audio.consts.Status;
import cn.efunbox.audio.entity.Admin;
import cn.efunbox.audio.entity.Channel;
import cn.efunbox.audio.entity.Trail;
import cn.efunbox.audio.impl.AdminServiceImpl;
import cn.efunbox.audio.impl.TrailServiceImpl;
import cn.efunbox.audio.service.AdminService;
import cn.efunbox.audio.service.ChannelService;
import cn.efunbox.audio.service.TrailService;
import cn.efunbox.audio.utils.ApiCode;
import cn.efunbox.audio.utils.Common;
import cn.efunbox.audio.utils.HttpUtil;
import com.netflix.discovery.converters.Auto;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Timestamp;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by yao on 17-9-26.
 */
@RestController
@Slf4j
@RequestMapping(value = "/trail")
public class TrailController {

    @Autowired
    TrailService trailService;
    @Autowired
    AdminService adminService;

    @RequestMapping(value = "/search" ,method = RequestMethod.POST)
    public void Search(HttpServletRequest request, HttpServletResponse response){
        String idAdmin = request.getParameter("idAdmin");
        String target = request.getParameter("target");
        String idTarget = request.getParameter("idTarget");
        String start = request.getParameter("start");
        String end = request.getParameter("end");
        String page = request.getParameter("page");
        String size = request.getParameter("size");
        if(page==null || page.length()<1)
            page = "0";
        if(size==null || size.length()<1)
            size = "0";
        Map<String,Object> map = new HashMap<>();
        Page<Trail> pageRes = null;
        if(target!=null && target.length()>0 && idTarget!=null && idTarget.length()>0)
            pageRes = trailService.SearchByTargetAndIdTarget(target, Long.valueOf(idTarget), Integer.valueOf(page), Integer.valueOf(size));
        else if((start==null || start.length()==0) || (end==null || end.length()==0)){
            if(idAdmin!=null && idAdmin.length()>0)
                pageRes = trailService.SearchByIdAdmin(Long.valueOf(idAdmin), Integer.valueOf(page), Integer.valueOf(size));
            else if(target!=null && target.length()>0)
                pageRes = trailService.SearchByTarget(target, Integer.valueOf(page), Integer.valueOf(size));
            else if(idTarget!=null && idTarget.length()>0)
                pageRes = trailService.SearchByIdTarget(Long.valueOf(idTarget), Integer.valueOf(page), Integer.valueOf(size));
            else
                pageRes = trailService.SearchAll(Integer.valueOf(page), Integer.valueOf(size));
        }else {
            if(idAdmin!=null && idAdmin.length()>0)
                pageRes = trailService.SearchByIdAdminAndCreatedBetween(Long.valueOf(idAdmin), Integer.valueOf(page), Integer.valueOf(size), Timestamp.valueOf(start), Timestamp.valueOf(end));
            else if(target!=null && target.length()>0)
                pageRes = trailService.SearchByTargetAndCreatedBetween(target, Integer.valueOf(page), Integer.valueOf(size), Timestamp.valueOf(start), Timestamp.valueOf(end));
            else if(idTarget!=null && idTarget.length()>0)
                pageRes = trailService.SearchByIdTargetAndCreatedBetween(Long.valueOf(idTarget), Integer.valueOf(page), Integer.valueOf(size), Timestamp.valueOf(start), Timestamp.valueOf(end));
            else
                pageRes = trailService.SearchByCreatedBetween(Integer.valueOf(page), Integer.valueOf(size), Timestamp.valueOf(start), Timestamp.valueOf(end));
        }


        if(pageRes!=null){
            map.put("data", pageRes.getContent());
            map.put("size", pageRes.getNumberOfElements());
            map.put("total", pageRes.getTotalElements());
        }

        HttpUtil.responseOkData(request, response, map);
        return;
    }

    /**
     * 插入新的记录，非接口形式
     * @param request
     * @param target
     * @param idTarget
     * @param desc
     * @return
     */
    public static Trail Insert(AdminService adminService, TrailService trailService, HttpServletRequest request, String target, Long idTarget, String desc){
        String id = request.getHeader("id");
        Admin adminOld = adminService.GetOne(Long.valueOf(id));
        Trail trail = new Trail();
        trail.setIdAdmin(Long.valueOf(id));
        trail.setCreated(new Timestamp(new Date().getTime()));
        trail.setTarget(target);
        trail.setIdTarget(idTarget);
        if(desc.length()>250)
            desc = desc.substring(0, 250);
        trail.setText("管理员 " + adminOld.getName() + desc);
        trail = trailService.Insert(trail);
        return trail;
    }

}
