package cn.efunbox.audio.impl.res;

import cn.efunbox.audio.entity.res.ResCategory;
import cn.efunbox.audio.repository.res.ResCategoryRepository;
import cn.efunbox.audio.service.res.GetTypeService;
import cn.efunbox.audio.utils.ResApiResult;
import cn.efunbox.audio.vo.res.TypeUpdateListVO;
import cn.efunbox.audio.vo.res.TypeUpdateVO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * GetTypeServiceImpl
 * Created by wangys on
 */
@Service
public class GetTypeServiceImpl implements GetTypeService {
    @Autowired
    private ResCategoryRepository resCategoryRepository;
    @Override
    public ResApiResult getTypeUpdateList(String beginTime, String order) throws ParseException {
        DateFormat dateFormat = new SimpleDateFormat("yyyymmddhhmmss");
        Date parse = null;
        if (StringUtils.isNotBlank(beginTime)){
            parse = dateFormat.parse(beginTime);
        }else {
            long time = 24*60*60*1000;
            time = System.currentTimeMillis() - time;
            parse = new Date(time);
        }
        List<ResCategory> resCategories = null;
        if (StringUtils.equals("desc",order)){
            resCategories = resCategoryRepository.getByGmtModifiedAfterOrderByGmtCreatedDesc(parse);
        }else {
            resCategories = resCategoryRepository.getByGmtModifiedAfterOrderByGmtCreated(parse);
        }
        List<TypeUpdateVO> updateVOList = getResAlbums(resCategories);
        TypeUpdateListVO typeUpdateListVO = new TypeUpdateListVO();
        typeUpdateListVO.setTypeList(updateVOList);
        return ResApiResult.ok(typeUpdateListVO);
    }
    private List<TypeUpdateVO> getResAlbums(List<ResCategory> resCategories) {
        List<TypeUpdateVO> updateVOList = new ArrayList<>();
        resCategories.forEach( resCategorie -> {
            TypeUpdateVO typeUpdateVO = new TypeUpdateVO();
            typeUpdateVO.setTypeId(resCategorie.getTypeId());
            typeUpdateVO.setTypeName(resCategorie.getTypeName());
            typeUpdateVO.setParentId(resCategorie.getParentId());
            typeUpdateVO.setTypeUpdatetime(resCategorie.getGmtCreated()+"");
            typeUpdateVO.setUpdateType(resCategorie.getRenewal());
            typeUpdateVO.setStatus(resCategorie.getIsDel());
            updateVOList.add(typeUpdateVO);
        });
        return updateVOList;
    }
}
