package cn.efunbox.audio.impl.res;

import cn.efunbox.audio.entity.res.ResUserEvent;
import cn.efunbox.audio.repository.res.ResUserEventRepository;
import cn.efunbox.audio.service.res.ResUserEventService;
import cn.efunbox.audio.utils.ResApiCode;
import cn.efunbox.audio.utils.ResApiResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class ResUserEventServiceImpl implements ResUserEventService {

    @Autowired
    ResUserEventRepository resUserEventRepository;

    /**
     * 记录日志
     * @param resUserEvent
     */
    @Override
    public ResApiResult recordLog(ResUserEvent resUserEvent) {

        try {
            resUserEventRepository.save(resUserEvent);
        } catch (Exception e) {
            log.info("日志记录发生异常：{}",e.getMessage());
            ResApiResult.error(ResApiCode.UNKNOWN_ERROR);
        }
        return ResApiResult.ok();
    }
}
