/**
 * 文件名：@Pageable.java <br/>
 * 包名：cn.efunbox.afw.core.domain.page <br/>
 * 项目名：afw-core <br/>
 * @author xtwin <br/>
 */
package cn.efunbox.audio.page;

/**
 * 类名：Pageable  <br />
 *
 * 功能：分页接口
 *
 * @author xtwin <br />
 * 创建时间：2016年7月28日 上午11:18:56  <br />
 * @version 2016年7月28日
 */
public interface Pageable<E> {
	
	/**
	 * 功能：当前页的数据内容 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年7月28日 上午11:43:27 <br/>
	 */
	E getList();

	/**
	 * 功能：总页数 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午9:47:45 <br/>
	 */
	int getTotalNo();
	
	/**
	 * 功能：总记录数 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午9:48:40 <br/>
	 */
	long getTotalSize();

	/**
	 * 功能：页码 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午9:48:33 <br/>
	 */
	int getPageNo();
	
	/**
	 * 功能：每页数据条数 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午9:48:25 <br/>
	 */
	int getPageSize();
	
	/**
	 * 功能：起始位置 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午10:02:52 <br/>
	 */
	int getStart();
	
	/**
	 * 功能：是否还有下一页 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午9:48:07 <br/>
	 */
	boolean hasNext();
	
	/**
	 * 功能：是否还有上一页 <br/>
	 *
	 * @author xtwin <br/>
	 * @version 2016年8月1日 上午9:47:58 <br/>
	 */
	boolean hasPrevious();
}
