package cn.efunbox.audio.repository;

import cn.efunbox.audio.entity.Device;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.sql.Timestamp;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@Repository
public interface DeviceRepo extends JpaRepository<Device, Long> {

    Device findById(Long id);
    Page<Device> findByIdDevice(String idDevice, Pageable pageable);
    Page<Device> findByIdChannel(Long idChannel, Pageable pageable);
    Page<Device> findByIdDeviceAndCreatedBetween(String idDevice, Timestamp start, Timestamp end, Pageable pageable);
    Page<Device> findByIdChannelAndCreatedBetween(Long idChannel, Timestamp start, Timestamp end, Pageable pageable);
    Page<Device> findByCreatedBetween(Timestamp start, Timestamp end, Pageable pageable);

    @Query("from Device d where d.idDevice=:idDevice")
    List<Device> findByDevice(@Param("idDevice")String idDevice);

    @Query("from Device d where d.idChannel=:idChannel")
    List<Device> findByChannel(@Param("idChannel")String idChannel);

    @Query("from Device d where d.idChannel=:idChannel and d.idDevice=:idDevice")
    List<Device> findByChannelDevice(@Param("idChannel")Long idChannel, @Param("idDevice")String idDevice);

}
