package cn.efunbox.audio.service;

import cn.efunbox.audio.entity.Audio;
import cn.efunbox.audio.entity.Record;
import org.springframework.data.domain.Page;

import java.sql.Date;
import java.sql.Timestamp;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
public interface RecordService {

    public Page<Record> SearchAll(int page, int size);

    public List<Record> SearchById(Long id);

    public Page<Record> SearchByIdChannel(Long id, int page, int size);

    public Page<Record> SearchByIdDevice(Long id, int page, int size);

    public Page<Record> SearchByIdAudio(Long id, int page, int size);

    public Page<Record> SearchCreatedBetween(int page, int size, Timestamp start, Timestamp end);

    public Page<Record> SearchByIdChannelAndCreatedBetween(Long id, int page, int size, Timestamp start, Timestamp end);

    public Page<Record> SearchByIdDeviceAndCreatedBetween(Long id, int page, int size, Timestamp start, Timestamp end);

    public Page<Record> SearchByIdAudioAndCreatedBetween(Long id, int page, int size, Timestamp start, Timestamp end);

    public Record Insert(Record record);

    public void Delete(Long id);
}
