package cn.efunbox.audio.vo.hag;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * HagSkillResp
 * Created by xusq on 2019/12/25.
 */
@Data
public class HagSkillResp extends HagBaseResp implements Serializable {

    private String version;

    private Reply reply;

    @Data
    public static final class Reply<T> implements Serializable {

        private Boolean isEndSession;
        private List<Command<T>> commands;

        @Data
        public static final class Command<T> implements Serializable {

            private Head head;
            private T body;

            public Command(){
                this.head = new Head();
            }

            @Data
            public class Head implements Serializable {
                private String namespace;
                private String name;
            }

            public void setNamespace(String namespace) {
                head.setNamespace(namespace);
            }

            public void setName(String name) {
                head.setName(name);
            }
        }

    }
}
