package cn.efunbox.audio.vo.hag;

import cn.efunbox.audio.entity.hag.HagProduct;
import cn.efunbox.audio.utils.DateUtil;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * AlbumConverter
 * Created by xusq on 2019/12/26.
 */
public class ProductConverter {

    private ProductConverter(){}

    public static ProductVO productToProductVO(HagProduct product){

        if (Objects.isNull(product)) {
            return null;
        }

        ProductVO productVO = new ProductVO();
        ProductVO.SkuInfo skuInfo = new ProductVO.SkuInfo();
        skuInfo.setAbilityId(product.getAbilityId());
        skuInfo.setCpSkuId(product.getId());
        skuInfo.setSkuName(product.getSkuName());
        skuInfo.setDescription(product.getDescription());
        skuInfo.setSkuType(product.getSkuType());
        skuInfo.setPriceController(product.getPriceController());
        skuInfo.setRightController(product.getRightController());
        skuInfo.setSkuReleaseState(product.getSkuReleaseState());

        productVO.setSkuInfo(skuInfo);

        ProductVO.Price productPrice = new ProductVO.Price();

       if (Objects.nonNull(product.getBeginTime())) {
          ProductVO.Price.TimeFilter timeFilter = new ProductVO.Price.TimeFilter();
        timeFilter.setBeginTime(product.getBeginTime());
        timeFilter.setEndTime(product.getEndTime());
         productPrice.setTimeFilter(timeFilter);
      }
       

        productPrice.setCurrency(product.getCurrency());
        productPrice.setPromotion(product.getPromotion());
        productPrice.setPriceGroupDescription(product.getPriceGroupDescription());
        

        ProductVO.Price.PriceItem priceItem = new ProductVO.Price.PriceItem();
        priceItem.setAmount(product.getAmount());
        priceItem.setOriginalAmount(product.getOriginalAmount());

        productPrice.setPricesItems(Arrays.asList(priceItem));

        productVO.setPrices(Arrays.asList(productPrice));


        productVO.setUpdateTime(DateUtil.dateFormatStr(product.getGmtModified()));

        List<ProductVO.ResourceRight> resourceRights = new ArrayList<>();
        ProductVO.ResourceRight resourceRight = new ProductVO.ResourceRight();
        resourceRight.setResourceType(product.getResourceType());
        resourceRight.setResourceId(product.getAlbumId());
        resourceRights.add(resourceRight);
       
        productVO.setResourceRights(resourceRights);

        return productVO;
    }
}
